%======================================================================
% Utilities for planners.
%
% "Prolog Programming for Artificial Intelligence", 2d Edition
%                        - by Ivan Bratko
%======================================================================

%----------------------------------------------------------------------
% conc( L1, L2, L3): Concatenates lists L1 and L2 to make list L3
%----------------------------------------------------------------------

conc( [], L, L).

conc( [ X | L1], L2, [ X | L3]) :-
        conc( L1, L2, L3).

%----------------------------------------------------------------------
% delete( +L1, +L2, -Diff): Diff is the list of all elements in list L1
%                           that are not also in list L2.
%----------------------------------------------------------------------

delete( [], _, []) :- !.

delete( [X | L1], L2, Diff) :-
        member( X, L2),!,
        delete( L1, L2, Diff).

delete( [X | L1], L2, [X | Diff]) :-
        delete( L1, L2, Diff).


member( X, [X|_] ).
member( X, [_|T] ) :-
    member( X, T ).
